(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     15223,        427]
NotebookOptionsPosition[     14211,        406]
NotebookOutlinePosition[     14606,        422]
CellTagsIndexPosition[     14563,        419]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[TextData[StyleBox["Figure 1 of \"Twisted cohomology and likelihood \
ideals\"", "Title",
 FontColor->RGBColor[0, 0, 1]]], "Input",
 CellChangeTimes->{{3.883391210534639*^9, 3.8833913034185743`*^9}, 
   3.884147501047653*^9},ExpressionUUID->"205e169d-fa7b-492f-88c1-\
b34740f2c25b"],

Cell["by Simon Telen and Saiei-Jaeyeong Matsubara-Heo (2023/01/22)", "Author",
 CellChangeTimes->{{3.8833913142491884`*^9, 
  3.8833913534389305`*^9}},ExpressionUUID->"8fd432e1-3cb0-4e69-a76d-\
eeae01e62ce3"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"s", " ", "=", 
   RowBox[{
    RowBox[{"1", "/", "2"}], "+", 
    RowBox[{"I", "*", "3"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nu", " ", "=", " ", 
   RowBox[{
    RowBox[{"1", "/", "7"}], "+", 
    RowBox[{"I", "*", "7"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f", "[", "z_", "]"}], " ", "=", " ", 
   RowBox[{"1", "-", 
    RowBox[{"z", "^", "3"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"G", "[", 
    RowBox[{"u_", ",", "v_"}], "]"}], " ", ":=", " ", 
   RowBox[{"Re", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "s"}], "*", 
      RowBox[{"Log", "[", 
       RowBox[{"f", "[", 
        RowBox[{"u", "+", 
         RowBox[{"I", "*", "v"}]}], "]"}], "]"}]}], " ", "+", " ", 
     RowBox[{"nu", "*", 
      RowBox[{"Log", "[", 
       RowBox[{"u", " ", "+", " ", 
        RowBox[{"I", "*", "v"}]}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"H", "[", 
    RowBox[{"u_", ",", "v_"}], "]"}], " ", ":=", " ", 
   RowBox[{"Im", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "s"}], "*", 
      RowBox[{"Log", "[", 
       RowBox[{"f", "[", 
        RowBox[{"u", "+", 
         RowBox[{"I", "*", "v"}]}], "]"}], "]"}]}], " ", "+", " ", 
     RowBox[{"nu", "*", 
      RowBox[{"Log", "[", 
       RowBox[{"u", " ", "+", " ", 
        RowBox[{"I", "*", "v"}]}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"G1", "[", 
    RowBox[{"u_", ",", "v_"}], "]"}], ":=", 
   RowBox[{"Re", "[", 
    RowBox[{"Log", "[", 
     RowBox[{"f", "[", 
      RowBox[{"u", "+", 
       RowBox[{"I", "*", "v"}]}], "]"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"G2", " ", "[", 
    RowBox[{"u_", ",", "v_"}], "]"}], " ", ":=", 
   RowBox[{"Re", "[", 
    RowBox[{"Log", "[", 
     RowBox[{"u", " ", "+", " ", 
      RowBox[{"I", "*", "v"}]}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Needs", "[", "\"\<NumericalCalculus`\>\"", 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"M", "[", 
    RowBox[{"u_", ",", "v_"}], "]"}], " ", "=", " ", 
   RowBox[{"1", "+", 
    RowBox[{
     RowBox[{"1", "/", "2"}], "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"ND", "[", 
         RowBox[{
          RowBox[{"G1", "[", 
           RowBox[{"uu", ",", "v"}], "]"}], ",", "uu", ",", "u"}], "]"}], "^",
         "2"}], " ", "+", 
       RowBox[{
        RowBox[{"ND", "[", 
         RowBox[{
          RowBox[{"G1", "[", 
           RowBox[{"u", ",", "vv"}], "]"}], ",", "vv", ",", "v"}], "]"}], "^",
         "2"}], " ", "+", " ", 
       RowBox[{
        RowBox[{"ND", "[", 
         RowBox[{
          RowBox[{"G2", "[", 
           RowBox[{"uu", ",", "v"}], "]"}], ",", "uu", ",", "u"}], "]"}], "^",
         "2"}], " ", "+", 
       RowBox[{
        RowBox[{"ND", "[", 
         RowBox[{
          RowBox[{"G2", "[", 
           RowBox[{"u", ",", "vv"}], "]"}], ",", "vv", ",", "v"}], "]"}], "^",
         "2"}]}], ")"}]}]}]}], ";"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.880887946989661*^9, 3.880887963313253*^9}, {
  3.88088799475347*^9, 3.880888019873684*^9}, {3.880888129282999*^9, 
  3.880888187366897*^9}, {3.880888249059091*^9, 3.880888266170553*^9}, {
  3.8808989014342527`*^9, 3.880898908492824*^9}, {3.880899355302249*^9, 
  3.880899428828721*^9}, {3.8811193635496264`*^9, 3.88111937017544*^9}, {
  3.8833036077532883`*^9, 3.883303609598633*^9}, {3.883391368337077*^9, 
  3.8833913697289762`*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"9bdfaf49-951f-46c3-92c8-0908e947722f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"p1", " ", "=", " ", 
   RowBox[{"StreamPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"1", "/", "2"}], "*", 
        RowBox[{
         RowBox[{"M", "[", 
          RowBox[{"u", ",", "v"}], "]"}], "^", 
         RowBox[{"(", 
          RowBox[{"-", "1"}], ")"}]}], 
        RowBox[{"ND", "[", 
         RowBox[{
          RowBox[{"G", "[", 
           RowBox[{"uu", ",", "v"}], "]"}], ",", "uu", ",", "u"}], "]"}]}], 
       ",", 
       RowBox[{
        RowBox[{"1", "/", "2"}], "*", 
        RowBox[{
         RowBox[{"M", "[", 
          RowBox[{"u", ",", "v"}], "]"}], "^", 
         RowBox[{"(", 
          RowBox[{"-", "1"}], ")"}]}], 
        RowBox[{"ND", "[", 
         RowBox[{
          RowBox[{"G", "[", 
           RowBox[{"u", ",", "vv"}], "]"}], ",", "vv", ",", "v"}], "]"}]}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"u", ",", 
       RowBox[{"-", "2"}], ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"v", ",", 
       RowBox[{"-", "2"}], ",", "2"}], "}"}], ",", 
     RowBox[{"StreamColorFunction", "\[Rule]", "None"}], ",", 
     RowBox[{"StreamPoints", "\[Rule]", "Fine"}], ",", 
     RowBox[{"StreamStyle", "\[Rule]", "LightGray"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.880888033744472*^9, 3.880888080035192*^9}, {
   3.8808881127315817`*^9, 3.8808881138232718`*^9}, {3.880888281631804*^9, 
   3.880888303170233*^9}, 3.880888863332921*^9, {3.880891093016508*^9, 
   3.8808910966862793`*^9}, {3.881119375047159*^9, 3.8811193813507147`*^9}, 
   3.883303593270746*^9, 3.88339145726805*^9, 3.883391605830765*^9},
 NumberMarks->False,ExpressionUUID->"ecf3f4a8-4fdc-4b95-a537-f71afdfc0713"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"pbluepoint", " ", "=", "  ", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"0.935", ",", 
        RowBox[{"-", "1.079"}]}], "}"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Thick", ",", "Blue", ",", 
        RowBox[{"Pointsize", "[", "Large", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"predpoint", " ", "=", "  ", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"0.464", ",", "1.348"}], "}"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Thick", ",", "Red", ",", 
        RowBox[{"Pointsize", "[", "Large", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pgreenpoint", " ", "=", "  ", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1.4"}], ",", 
        RowBox[{"-", "0.272"}]}], "}"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Thick", ",", "Green", ",", 
        RowBox[{"Pointsize", "[", "Large", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.880888553206828*^9, 3.880888631146757*^9}, {
  3.8808887591836443`*^9, 3.8808887640213633`*^9}, {3.880888804981896*^9, 
  3.880888840783532*^9}, {3.880892735125937*^9, 3.880892786489541*^9}, {
  3.880892834804976*^9, 3.880892947672246*^9}, {3.880892991689802*^9, 
  3.880893041816081*^9}, {3.880893110188237*^9, 3.8808931318884153`*^9}, {
  3.883391579946834*^9, 
  3.883391581860391*^9}},ExpressionUUID->"6e362350-0972-49ad-9d88-\
fbd85a94fb48"],

Cell[BoxData[
 RowBox[{
  RowBox[{"pblue", "=", 
   RowBox[{"ContourPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"H", "[", 
         RowBox[{"x", ",", "y"}], "]"}], " ", "==", 
        RowBox[{"H", "[", 
         RowBox[{"0.9351617067039671", ",", 
          RowBox[{"-", "1.075899875356462"}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"H", "[", 
         RowBox[{"x", ",", "y"}], "]"}], " ", "==", 
        RowBox[{
         RowBox[{"H", "[", 
          RowBox[{"0.9351617067039671", ",", 
           RowBox[{"-", "1.075899875356462"}]}], "]"}], "+", "Pi"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"H", "[", 
         RowBox[{"x", ",", "y"}], "]"}], " ", "==", 
        RowBox[{
         RowBox[{"H", "[", 
          RowBox[{"0.9351617067039671", ",", 
           RowBox[{"-", "1.075899875356462"}]}], "]"}], "+", 
         RowBox[{"2", "*", "Pi"}]}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "2"}], ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"y", ",", 
       RowBox[{"-", "2"}], ",", "2"}], "}"}], ",", 
     RowBox[{"ContourStyle", "->", "Blue"}], ",", 
     RowBox[{"RegionFunction", "->", 
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"x", ",", "y"}], "}"}], ",", 
        RowBox[{"y", "<", " ", 
         RowBox[{
          RowBox[{"0.769", "*", "x"}], "+", "0.923"}]}]}], "]"}]}], ",", 
     RowBox[{"BoundaryStyle", "->", "Red"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.880891341095488*^9, 3.880891401497463*^9}, {
   3.8808916725746937`*^9, 3.880891711446282*^9}, 3.8833035532562733`*^9, 
   3.883391546949575*^9, 
   3.883391610369471*^9},ExpressionUUID->"1a148108-9245-4e0b-a0fb-\
c4cb3d3f7f05"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"pred", " ", "=", " ", 
    RowBox[{"ContourPlot", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"H", "[", 
          RowBox[{"x", ",", "y"}], "]"}], " ", "==", " ", 
         RowBox[{"H", "[", 
          RowBox[{"0.4641757706352235", ",", "1.3478237323302797"}], "]"}]}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"H", "[", 
          RowBox[{"x", ",", "y"}], "]"}], " ", "==", " ", 
         RowBox[{
          RowBox[{"H", "[", 
           RowBox[{"0.4641757706352235", ",", "1.3478237323302797"}], "]"}], 
          "+", "Pi"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"H", "[", 
          RowBox[{"x", ",", "y"}], "]"}], " ", "==", " ", 
         RowBox[{
          RowBox[{"H", "[", 
           RowBox[{"0.4641757706352235", ",", "1.3478237323302797"}], "]"}], 
          "+", 
          RowBox[{"2", "*", "Pi"}]}]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{"-", "2"}], ",", "2"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y", ",", 
        RowBox[{"-", "2"}], ",", "2"}], "}"}], ",", 
      RowBox[{"ContourStyle", "->", "Red"}], ",", 
      RowBox[{"RegionFunction", "->", 
       RowBox[{"Function", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"x", ",", "y"}], "}"}], ",", 
         RowBox[{"y", ">", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "0.75"}], "*", "x"}], "-", "0.5"}]}]}], "]"}]}], ",", 
      RowBox[{"BoundaryStyle", "->", "Red"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pgreen", " ", "=", " ", 
   RowBox[{"ContourPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"H", "[", 
         RowBox[{"x", ",", "y"}], "]"}], " ", "==", 
        RowBox[{"H", "[", 
         RowBox[{
          RowBox[{"-", "1.3993374773391904"}], ",", 
          RowBox[{"-", "0.2719238569738171"}]}], "]"}]}], ",", " ", 
       RowBox[{
        RowBox[{"H", "[", 
         RowBox[{"x", ",", "y"}], "]"}], " ", "==", 
        RowBox[{
         RowBox[{"H", "[", 
          RowBox[{
           RowBox[{"-", "1.3993374773391904"}], ",", 
           RowBox[{"-", "0.2719238569738171"}]}], "]"}], "+", "Pi"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"H", "[", 
         RowBox[{"x", ",", "y"}], "]"}], " ", "==", 
        RowBox[{
         RowBox[{"H", "[", 
          RowBox[{
           RowBox[{"-", "1.3993374773391904"}], ",", 
           RowBox[{"-", "0.2719238569738171"}]}], "]"}], "+", 
         RowBox[{"2", "*", "Pi"}]}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "2"}], ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"y", ",", 
       RowBox[{"-", "2"}], ",", "2"}], "}"}], ",", 
     RowBox[{"ContourStyle", "->", "Green"}], ",", 
     RowBox[{"RegionFunction", "->", 
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"x", ",", "y"}], "}"}], ",", 
        RowBox[{
         RowBox[{"y", "<", " ", 
          RowBox[{
           RowBox[{"0.769", "*", "x"}], "+", "0.923"}]}], " ", "&&", " ", 
         RowBox[{"x", "<", "0.80"}]}]}], "]"}]}], ",", 
     RowBox[{"BoundaryStyle", "->", "Red"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.880891716264949*^9, 3.880891743632999*^9}, {
  3.880891802624221*^9, 3.8808918151616793`*^9}, {3.880891862242872*^9, 
  3.8808918647393427`*^9}, {3.880891902621173*^9, 3.880891905916811*^9}, {
  3.880892095974827*^9, 3.8808921862955933`*^9}, {3.883303540852253*^9, 
  3.88330356424572*^9}},
 CellLabel->"In[17]:=",ExpressionUUID->"c62f7bb1-384e-46c4-af6d-347c725908db"],

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{
  "p1", ",", "pblue", ",", "pred", ",", "pgreen", ",", "pbluepoint", ",", 
   "predpoint", ",", "pgreenpoint"}], "]"}]], "Input",
 CellChangeTimes->{{3.8808922536253366`*^9, 3.8808922585203533`*^9}, {
   3.8808929636370707`*^9, 3.880892976102335*^9}, 
   3.8833916490821896`*^9},ExpressionUUID->"f0c6aa57-91cf-4587-8878-\
4d89f61d8ae9"]
},
WindowSize->{654, 927},
WindowMargins->{{Automatic, 197}, {-22, Automatic}},
FrontEndVersion->"12.3 for Mac OS X x86 (64-bit) (June 19, 2021)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"fb096eab-f26e-46b2-8643-7179fd9c28fd"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 286, 5, 71, "Input",ExpressionUUID->"205e169d-fa7b-492f-88c1-b34740f2c25b"],
Cell[847, 27, 208, 3, 57, "Author",ExpressionUUID->"8fd432e1-3cb0-4e69-a76d-eeae01e62ce3"],
Cell[1058, 32, 3686, 110, 283, "Input",ExpressionUUID->"9bdfaf49-951f-46c3-92c8-0908e947722f"],
Cell[4747, 144, 1726, 46, 94, "Input",ExpressionUUID->"ecf3f4a8-4fdc-4b95-a537-f71afdfc0713"],
Cell[6476, 192, 1737, 47, 136, "Input",ExpressionUUID->"6e362350-0972-49ad-9d88-fbd85a94fb48"],
Cell[8216, 241, 1833, 50, 157, "Input",ExpressionUUID->"1a148108-9245-4e0b-a0fb-c4cb3d3f7f05"],
Cell[10052, 293, 3768, 101, 325, "Input",ExpressionUUID->"c62f7bb1-384e-46c4-af6d-347c725908db"],
Cell[13823, 396, 384, 8, 30, "Input",ExpressionUUID->"f0c6aa57-91cf-4587-8878-4d89f61d8ae9"]
}
]
*)

